'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _helperFunctions = require('./helperFunctions');

var _SVGPrev = require('./svg/SVGPrev');

var _SVGPrev2 = _interopRequireDefault(_SVGPrev);

var _SVGNext = require('./svg/SVGNext');

var _SVGNext2 = _interopRequireDefault(_SVGNext);

var _reactMediumImageZoom = require('react-medium-image-zoom');

var _reactMediumImageZoom2 = _interopRequireDefault(_reactMediumImageZoom);

var _OutsideClickListener = require('./OutsideClickListener');

var _OutsideClickListener2 = _interopRequireDefault(_OutsideClickListener);

var _Accordion = require('./Accordion');

var _Accordion2 = _interopRequireDefault(_Accordion);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _defaultStyles = require('./defaultStyles');

var _PointerUser = require('./PointerUser');

var _PointerUser2 = _interopRequireDefault(_PointerUser);

var _reactSwipeable = require('react-swipeable');

var _reactSwipeable2 = _interopRequireDefault(_reactSwipeable);

var _recompose = require('recompose');

var _KBListener = require('./KBListener');

var _KBListener2 = _interopRequireDefault(_KBListener);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
- gradual image transitions
- highlight current selection
*/

var ImageViewer = function ImageViewer(_ref) {
  var srcs = _ref.srcs,
      disableDiscreteNavButtons = _ref.disableDiscreteNavButtons,
      accordionProps = _ref.accordionProps,
      swipeableProps = _ref.swipeableProps,
      layout = _ref.layout,
      className = _ref.className,
      style = _ref.style,
      onClick = _ref.onClick,
      cssImageUnzoomedClass = _ref.cssImageUnzoomedClass,
      cssImageZoomedInClass = _ref.cssImageZoomedInClass,
      unzoomedImageProps = _ref.unzoomedImageProps,
      zoomedInImageProps = _ref.zoomedInImageProps,
      renderTopRight = _ref.renderTopRight,
      frameHeight = _ref.frameHeight,
      frameWidth = _ref.frameWidth,
      itemWidth = _ref.itemWidth,
      itemHeight = _ref.itemHeight,
      renderMidArea = _ref.renderMidArea,
      renderOption = _ref.renderOption,
      renderOptions = _ref.renderOptions;

  var _useReducer = (0, _react.useReducer)(function (state, newState) {
    return (0, _extends3.default)({}, state, newState);
  }, {
    isActive: false,
    activeSrc: srcs[0]
  }),
      _useReducer2 = (0, _slicedToArray3.default)(_useReducer, 2),
      state = _useReducer2[0],
      setState = _useReducer2[1];

  var activeSrc = state.activeSrc,
      isActive = state.isActive;


  var arrayOfRefs = (0, _from2.default)({ length: srcs.length }, function () {
    return _react2.default.createRef();
  });

  (0, _react.useEffect)(function () {
    setState({ activeSrc: srcs[0] });
  }, [srcs]);

  var externalSwipeableRef = (0, _react.useRef)(null);
  var containerRef = (0, _react.useRef)(null);
  var imageFrameRef = (0, _react.useRef)(null);

  var setSrc = function setSrc(destination) {
    var currentIndex = srcs.indexOf(activeSrc);

    var previewImageElement = void 0,
        destinationIndex = void 0;

    switch (destination) {
      case 'prev':
        if (currentIndex === 0) {
          destinationIndex = srcs.length - 1;
        } else {
          destinationIndex = currentIndex - 1;
        }
        break;
      case 'next':
        if (currentIndex === srcs.length - 1) {
          destinationIndex = 0;
        } else {
          destinationIndex = currentIndex + 1;
        }
        break;
      default:
        destinationIndex = destination;
    }

    setState({ activeSrc: srcs[destinationIndex] });
    console.log(activeSrc, arrayOfRefs[destinationIndex]);
    previewImageElement = arrayOfRefs[destinationIndex].current;

    previewImageElement.scrollIntoView({ behavior: 'smooth' });
  };

  var getSharedTopButtonStyle = function getSharedTopButtonStyle() {
    //const height =
    //  imageFrameRef.current && imageFrameRef.current.getBoundingClientRect().height
    return {
      display: disableDiscreteNavButtons ? 'none' : srcs.length * itemWidth > frameWidth ? 'flex' : 'none',
      position: 'absolute',
      top: 0,
      padding: 0,
      zIndex: 1,
      height: '100%'
    };
  };
  var getSharedBottomButtonStyle = function getSharedBottomButtonStyle() {
    //const height =
    //  imageFrameRef.current && imageFrameRef.current.getBoundingClientRect().height
    return {
      display: disableDiscreteNavButtons ? 'none' : srcs.length * itemWidth > frameWidth ? 'none' : 'flex',
      height: '2.5rem',
      width: '2.5rem',
      margin: '0 1.75rem',
      border: '1px solid white',
      padding: '1rem',
      zIndex: 1
    };
  };

  var getOptionProps = function getOptionProps(src, i) {
    return function () {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var className = _ref2.className,
          style = _ref2.style,
          _onClick = _ref2.onClick,
          props = (0, _objectWithoutProperties3.default)(_ref2, ['className', 'style', 'onClick']);

      return (0, _extends3.default)({
        style: (0, _extends3.default)({
          backgroundImage: 'url(\'' + src + '\')'

        }, style),
        key: i,
        onClick: function onClick(e) {
          for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
            args[_key - 1] = arguments[_key];
          }

          _onClick && _onClick.apply(undefined, [e].concat(args));
          setSrc(i);
        },

        id: 'imageviewer__preview__item-' + i,
        className: className ? (0, _helperFunctions.flippyClass)(src === activeSrc, 'imageviewer__preview__item', 'active', 'inactive') + ' ' + (0, _helperFunctions.flippyClass)(src === activeSrc, className, 'active', 'inactive') : (0, _helperFunctions.flippyClass)(src === activeSrc, 'imageviewer__preview__item', 'active', 'inactive')
      }, props);
    };
  };

  return _react2.default.createElement(
    _KBListener2.default,
    {
      onKBLeftArrow: function onKBLeftArrow() {
        if (isActive) {
          setSrc('prev');
        }
      },
      onKBRightArrow: function onKBRightArrow() {
        if (isActive) {
          setSrc('next');
        }
      }
    },
    _react2.default.createElement(
      _OutsideClickListener2.default,
      {
        containerRef: containerRef,
        handler: function handler() {
          return setState({ isActive: false });
        },
        insideHandler: function insideHandler() {
          return setState({ isActive: true });
        }
      },
      _react2.default.createElement(
        'div',
        {
          onClick: onClick,
          className: className ? className + ' imageviewer__container' : 'imageviewer__container',
          ref: containerRef,
          style: (0, _extends3.default)({
            display: 'flex',
            flexDirection: layout === 'vertical' ? 'row' : 'column',
            alignItems: 'center',
            justifyContent: 'center'
          }, style)
        },
        _react2.default.createElement(
          'div',
          {
            className: 'imageviewer__imagewrapper',
            style: { display: 'flex', alignItems: 'center' }
          },
          _react2.default.createElement(
            'div',
            {
              className: 'imageviewer__imageframe',
              ref: imageFrameRef,
              style: {
                position: 'relative',
                display: 'flex',
                justifyContent: 'center'
                //width: frameWidth,
                //height: frameHeight,
              }
            },
            _react2.default.createElement(
              _Button2.default,
              {
                onClick: function onClick() {
                  return setSrc('prev');
                },
                className: 'imageviewer__topnav imageviewer__topnav__left',
                colors: _defaultStyles.buttonStyles.transparentNeutral,
                style: (0, _extends3.default)({}, getSharedTopButtonStyle(), { left: -24 })
              },
              _react2.default.createElement(_SVGPrev2.default, { size: '24', fill: '#666666' })
            ),
            _react2.default.createElement(
              _reactSwipeable2.default,
              {
                onSwipedLeft: function onSwipedLeft(e, absX) {
                  setSrc('prev');
                },
                onSwipedRight: function onSwipedRight(e, absX) {
                  setSrc('next');
                },
                className: 'imageviewer__image',
                style: {
                  display: 'flex',
                  alignItems: 'center',
                  justifyContent: 'center'
                }
              },
              _react2.default.createElement(_reactMediumImageZoom2.default, {
                image: (0, _extends3.default)({
                  src: activeSrc,
                  className: cssImageUnzoomedClass
                }, unzoomedImageProps),
                zoomImage: (0, _extends3.default)({
                  src: activeSrc,
                  className: cssImageZoomedInClass
                }, zoomedInImageProps)
              })
            ),
            _react2.default.createElement(
              _Button2.default,
              {
                onClick: function onClick() {
                  return setSrc('next');
                },
                className: 'imageviewer__topnav imageviewer__topnav__right',
                colors: _defaultStyles.buttonStyles.transparentNeutral,
                style: (0, _extends3.default)({}, getSharedTopButtonStyle(), { right: -24 })
              },
              _react2.default.createElement(_SVGNext2.default, { size: '24', fill: '#666666' })
            )
          )
        ),
        renderMidArea && renderMidArea(),
        renderOptions ? renderOptions({ getOptionProps: getOptionProps, srcs: srcs, activeSrc: activeSrc }) : _react2.default.createElement(
          'div',
          {
            style: { position: 'relative', display: 'flex' },
            className: 'imageviewer__preview__container'
          },
          _react2.default.createElement(
            _Button2.default,
            {
              onClick: function onClick() {
                return setSrc('prev');
              },
              colors: _defaultStyles.buttonStyles.transparentNeutral,
              style: (0, _extends3.default)({}, getSharedBottomButtonStyle())
            },
            _react2.default.createElement(_SVGPrev2.default, { size: '24', fill: '#666666' })
          ),
          _react2.default.createElement(
            _Accordion2.default,
            {
              externalSwipeableRef: externalSwipeableRef,
              swipeableProps: (0, _extends3.default)({
                style: {
                  overflow: 'hidden',
                  display: 'flex',

                  flexDirection: layout === 'vertical' ? 'column' : 'row',
                  width: layout === 'vertical' ? null : srcs.length * itemWidth > frameWidth ? frameWidth : srcs.length * itemWidth,
                  height: layout === 'vertical' ? srcs.length * itemHeight > frameHeight ? frameHeight : srcs.length * itemHeight : null
                },
                className: 'imageviewer__preview__items'
              }, accordionProps)
            },
            srcs.map(function (src, i) {
              return renderOption ? renderOption({
                containerRef: arrayOfRefs[i],
                getOptionProps: getOptionProps(src, i),
                isActive: activeSrc === src
              }) : _react2.default.createElement(_Button2.default, (0, _extends3.default)({
                isOn: src === activeSrc,
                colors: {
                  transition: 'smooth',
                  on: { backgroundColor: '#eeea' },
                  off: { backgroundColor: '#3333' },
                  disabled: { backgroundColor: '#ccc', color: '#888' },
                  diff: 30
                },
                containerRef: arrayOfRefs[i]
              }, getOptionProps(src, i)({
                style: {
                  backgroundSize: 'auto 90%',
                  minWidth: '4rem',
                  minHeight: '8rem'
                }
              })));
            })
          ),
          _react2.default.createElement(
            _Button2.default,
            {
              onClick: function onClick() {
                return setSrc('next');
              },
              colors: _defaultStyles.buttonStyles.transparentNeutral,
              style: (0, _extends3.default)({}, getSharedBottomButtonStyle())
            },
            _react2.default.createElement(_SVGNext2.default, { size: '24', fill: '#666666' })
          )
        )
      )
    )
  );
};

ImageViewer.propTypes = {
  srcs: _propTypes2.default.arrayOf(_propTypes2.default.string.isRequired).isRequired
};
var enhance = (0, _recompose.compose)((0, _recompose.defaultProps)({
  frameHeight: 350,
  frameWidth: 250,
  itemWidth: 55,
  itemHeight: 80,

  srcs: (0, _from2.default)({ length: 8 }, function (_, i) {
    return 'https://loremflickr.com/210/300?random=' + i;
  }),
  zoomedInImageProps: {},
  unzoomedImageProps: {
    style: {
      height: '30rem'
    }
  },
  cssImageUnzoomedClass: 'imageviewer__image--unzoomed',
  cssImageZoomedInClass: 'imageviewer__image--zoomed-in'
}));

exports.default = enhance(ImageViewer);